package com.intershop.support.component.mycoupon.internal;

import javax.inject.Inject;

import com.google.inject.Injector;
import com.intershop.beehive.businessobject.capi.BusinessObjectExtension;
import com.intershop.component.repository.capi.AbstractDomainRepositoryBOExtensionFactory;
import com.intershop.component.repository.capi.RepositoryBO;
import com.intershop.support.component.mycoupon.capi.MyCouponBORepository;

/**
 * Factory class for the {@link MyCouponBORepository}.
 */
public class MyCouponBORepositoryExtensionFactory extends AbstractDomainRepositoryBOExtensionFactory
{
    @Inject
    private Injector injector; 
    
    @Override
    public BusinessObjectExtension<RepositoryBO> createExtension(RepositoryBO repository)
    {
        MyCouponBORepositoryImpl myCouponBORepositoryImpl = new MyCouponBORepositoryImpl(MyCouponBORepository.EXTENSION_ID, repository);
        injector.injectMembers(myCouponBORepositoryImpl);
        return myCouponBORepositoryImpl;
    }

    @Override
    public String getExtensionID()
    {
        return MyCouponBORepository.EXTENSION_ID;
    }
}
